{ :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  :: Bugs Free QuickReport 3.0 for Delphi and C++Builder     ::
  ::                                                         ::
  :: QRColEd.PAS - Printer Pool component                    ::
  ::                                                         ::
  :: Copyright (c) 2000 Bugs Free QR Team                    ::
  ::                                                         ::
  :: web: http://bfqr.nm.ru                                  ::
  ::                                                         ::
  ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: }

unit QRPool;

interface
uses Classes, contnrs;

type

  TQRPrinterPool = class(TPersistent)
  private
    FPrinterList: TComponentList;
    function GetQRPrinter(Index: Integer): TComponent;
    function GetCount: Integer;
  protected
//    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
  public
    constructor Create; virtual;
    destructor Destroy; override;
    function AddPrinter(aQRPrinter: TComponent): Integer;
    function ReleasePrinter(aQRPrinter: TComponent): Integer;
    function RemovePrinter(aQRPrinter: TComponent): TComponent;
    property QRPrinters[Index: Integer]: TComponent read GetQRPrinter;
    property Count: Integer read GetCount;
  end;

implementation

{ TQRPrinterPool }

function TQRPrinterPool.AddPrinter(aQRPrinter: TComponent): Integer;
begin
  Result := FPrinterList.IndexOf(aQRPrinter);
  if Assigned(aQRPrinter) and (Result < 0)  then
    Result := FPrinterList.Add(aQRPrinter);
end;

constructor TQRPrinterPool.Create;
begin
  inherited Create;
  FPrinterList := TComponentList.Create(True);
end;

destructor TQRPrinterPool.Destroy;
//var
//  I: Integer;
//  P: TQRPRinter;
begin
//  if
  FPrinterList.Free;
  inherited Destroy;
end;

function TQRPrinterPool.GetCount: Integer;
begin
  Result := FPrinterList.Count;
end;

function TQRPrinterPool.GetQRPrinter(Index: Integer): TComponent;
begin
  Result := nil;
  if Index < FPrinterList.Count
//  if Index > FPrinterList.Count-1
  then Result := FPrinterList.Items[Index];
end;

function TQRPrinterPool.ReleasePrinter(aQRPrinter: TComponent): Integer;
begin
{
  if Assigned(aQRPrinter)
  and Assigned(aQRPrinter.Owner)
  and (csDesigning in aQRPrinter.Owner.ComponentState) then begin
    aQRPrinter.Owner.RemoveComponent(aQRPrinter);
  end;
}
  Result := -1;
  if FPrinterList.Count > 0 then
    Result := FPrinterList.Remove(aQRPrinter);
end;

function TQRPrinterPool.RemovePrinter(aQRPrinter: TComponent): TComponent;
begin
  Result := nil;
  if FPrinterList.Count > 0 then
    Result := FPrinterList.Extract(aQRPrinter);
end;
{
procedure TQRPrinterPool.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
end;
}
end.
