{===================================================================================================

  Comming Library

    ""    .

====================================================================================================

  :

  25.07.2007  [*] .
  14.11.2002  [*]   .
  09.01.2001  [*]   .
              [*]  Bottom.
              [*]  Max  Min .
  08.01.2001  [*]  ContBottom.
  24.12.2000  [*]   TcoBindingMenu  .
  22.12.2000  [+]  .  .
  09.09.1998  [!]  Comming Library.

====================================================================================================
  Copyright 19982007 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: CommingBinding.pas,v 1.5 2007/07/26 04:02:28 tsk Exp $
===================================================================================================}
unit CommingBinding;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
      StdCtrls, ComCtrls, ExtCtrls, DesignIntf, DesignEditors;

{ TBinding }
type
  TBinding = class( TForm )
    pnTop: TPanel;
    cbContTop: TComboBox;
    cbIndTop: TCheckBox;
    edIndTop: TEdit;
    udIndTop: TUpDown;
    cbAnchTop: TCheckBox;
    pnLeft: TPanel;
    cbContLeft: TComboBox;
    cbIndLeft: TCheckBox;
    edIndLeft: TEdit;
    udIndLeft: TUpDown;
    cbAnchLeft: TCheckBox;
    pnBottom: TPanel;
    cbContBottom: TComboBox;
    cbIndBottom: TCheckBox;
    edIndBottom: TEdit;
    udIndBottom: TUpDown;
    cbAnchBottom: TCheckBox;
    pnRight: TPanel;
    cbContRight: TComboBox;
    cbIndRight: TCheckBox;
    edIndRight: TEdit;
    udIndRight: TUpDown;
    cbAnchRight: TCheckBox;
    pnControl: TPanel;
    edLeft: TEdit;
    udLeft: TUpDown;
    edTop: TEdit;
    udTop: TUpDown;
    edBottom: TEdit;
    udBottom: TUpDown;
    edRight: TEdit;
    udRight: TUpDown;
    procedure FormCreate(Sender: TObject);
    procedure cbIndLeftClick(Sender: TObject);
    procedure cbContLeftChange(Sender: TObject);
    procedure edLeftChange(Sender: TObject);
    procedure cbAnchLeftClick(Sender: TObject);
    procedure edTopChange(Sender: TObject);
    procedure cbIndTopClick(Sender: TObject);
    procedure cbAnchTopClick(Sender: TObject);
    procedure cbContTopChange(Sender: TObject);
    procedure edRightChange(Sender: TObject);
    procedure cbIndRightClick(Sender: TObject);
    procedure cbAnchRightClick(Sender: TObject);
    procedure edBottomChange(Sender: TObject);
    procedure cbIndBottomClick(Sender: TObject);
    procedure cbAnchBottomClick(Sender: TObject);
    procedure cbContBottomChange(Sender: TObject);
    procedure cbContRightChange(Sender: TObject);
  private   { Private declarations }
    FControl: TControl;
    FControlList: TStringList;
    FContLeft: Integer;
    FContTop: Integer;
    FContRight: Integer;
    FContBottom: Integer;
    procedure SetContLeft( const Value: Integer );
    procedure SetContTop( const Value: Integer );
    procedure SetContRight( const Value: Integer );
    procedure SetContBottom( const Value: Integer );
  public    { Public declarations }
    procedure Init( Cont: TControl );
    property  ContLeft: Integer read FContLeft write SetContLeft;
    property  ContTop: Integer read FContTop write SetContTop;
    property  ContRight: Integer read FContRight write SetContRight;
    property  ContBottom: Integer read FContBottom write SetContBottom;
  end;

{ TcoBindingMenu }
type
  TcoBindingMenu = Class( TComponentEditor )
  protected
    FControl : TControl;
  public    { Public declarations }
    constructor Create(AComponent: TComponent; ADesigner: IDesigner); override;
    procedure   ExecuteVerb(Index: integer); override;
    function    GetVerb(Index: integer): string; override;
    function    GetVerbCount : integer; override;
  end;

  procedure BindingControl( Cont: TControl );

var BindingForm: TBinding;

implementation

{$R *.DFM}

procedure BindingControl( Cont: TControl );
begin
  BindingForm := TBinding.Create( Application );
  BindingForm.Init( Cont );
  BindingForm.ShowModal;
  BindingForm.Free;
end;

//==================================================================================================
{ TBinding }
//==================================================================================================
procedure TBinding.Init( Cont: TControl );
  var i: Integer;
      p: TControl;
begin
  FControl := Cont;
  pnControl.Caption := FControl.Name + ':' + FControl.ClassName;
//  :
  ContLeft    := FControl.Left;
  ContTop     := FControl.Top;
  ContRight   := FControl.Left + FControl.Width;
  ContBottom  := FControl.Top + FControl.Height;
// :
  FControlList := TStringList.Create;
  FControlList.Sorted := True;
  p := TControl( Cont.Owner );
  FControlList.AddObject( Cont.Parent.Name + ':' + Cont.Parent.ClassName, Cont.Parent );
  for i := 0 to p.ComponentCount - 1 do begin
    if ( p.Components[i] is TControl ) and
          ( p.Components[i] <> Cont ) and
          ( TControl( p.Components[i] ).Parent = Cont.Parent ) then
      FControlList.AddObject( p.Components[i].Name + ':' + p.Components[i].ClassName,
                              p.Components[i] );
  end;
//  :
  cbContLeft.Items.Assign( FControlList );
  cbAnchLeft.Checked    := ( akLeft in Cont.Anchors );
  cbIndLeft.Checked     := False;
//  
  cbContTop.Items.Assign( FControlList );
  cbAnchTop.Checked     := ( akTop in Cont.Anchors );
  cbIndTop.Checked      := False;
//  
  cbContRight.Items.Assign( FControlList );
  cbAnchRight.Checked   := ( akRight in Cont.Anchors );
  cbIndRight.Checked    := False;
//  
  cbContBottom.Items.Assign( FControlList );
  cbAnchBottom.Checked  := ( akBottom in Cont.Anchors );
  cbIndBottom.Checked   := False;
end;
//==================================================================================================
procedure TBinding.FormCreate(Sender: TObject);
begin
  udLeft.Max      := GetSystemMetrics(SM_CXFULLSCREEN);
  udLeft.Min      := - udLeft.Max;
  udIndLeft.Max   := GetSystemMetrics(SM_CXFULLSCREEN);
  udIndLeft.Min   := - udIndLeft.Max;
  udTop.Max       := GetSystemMetrics(SM_CYFULLSCREEN);
  udTop.Min       := - udTop.Max;
  udIndTop.Max    := GetSystemMetrics(SM_CYFULLSCREEN);
  udIndTop.Min    := - udIndTop.Max;
  udRight.Max     := GetSystemMetrics(SM_CXFULLSCREEN);
  udIndRight.Max  := GetSystemMetrics(SM_CXFULLSCREEN);
  udIndRight.Min  := - udIndLeft.Max;
  udBottom.Max    := GetSystemMetrics(SM_CYFULLSCREEN);
  udIndBottom.Max := GetSystemMetrics(SM_CYFULLSCREEN);
  udIndBottom.Min := - udIndTop.Max;
  Left            := GetSystemMetrics(SM_CXFULLSCREEN) - Width - 10;
  Top             := GetSystemMetrics(SM_CYFULLSCREEN) - Height - 10;
end;
//==================================================================================================
{ Left }
//==================================================================================================
procedure TBinding.SetContLeft( const Value: Integer );
  var c: TControl;
begin
  if FContLeft <> Value then begin
    FContLeft           := Value;
    FControl.Left       := FContLeft;
    if cbAnchRight.Checked
      then FControl.Width := FContRight - FContLeft
      else ContRight      := FContLeft + FControl.Width;
    edLeft.OnChange     := nil;
    udLeft.Position     := FContLeft;
    edLeft.OnChange     := edLeftChange;
    if cbIndLeft.Checked then begin
      edIndLeft.OnChange  := nil;
      c := ( FControlList.Objects[cbContLeft.ItemIndex] as TControl);
      if c = FControl.Parent
        then udIndLeft.Position := FContLeft
        else udIndLeft.Position := FContLeft - c.Left - c.Width;
      edIndLeft.OnChange  := cbIndLeftClick;
    end;
  end;
end;
//==================================================================================================
procedure TBinding.edLeftChange(Sender: TObject);
begin
  ContLeft := udLeft.Position;
end;
//==================================================================================================
procedure TBinding.cbContLeftChange(Sender: TObject);
begin
  cbIndLeft.Enabled := ( cbContLeft.ItemIndex >= 0 );
  cbIndLeftClick( Sender );
end;
//==================================================================================================
procedure TBinding.cbIndLeftClick( Sender: TObject );
  var c: TControl;
begin
  if cbIndLeft.Checked then begin
    c := ( FControlList.Objects[cbContLeft.ItemIndex] as TControl);
    if c = FControl.Parent
      then ContLeft := udIndLeft.Position
      else ContLeft := c.Left + c.Width + udIndLeft.Position;
  end;
end;
//==================================================================================================
procedure TBinding.cbAnchLeftClick(Sender: TObject);
begin
  if cbAnchLeft.Checked
    then FControl.Anchors := FControl.Anchors + [akLeft]
    else FControl.Anchors := FControl.Anchors - [akLeft];
end;
//==================================================================================================
{ Top }
//==================================================================================================
procedure TBinding.SetContTop( const Value: Integer );
  var c: TControl;
begin
  if FContTop <> Value then begin
    FContTop           := Value;
    FControl.Top       := FContTop;
    if cbAnchBottom.Checked
      then FControl.Height := FContBottom - FContTop
      else ContBottom      := FContTop + FControl.Height;
    edTop.OnChange     := nil;
    udTop.Position     := FContTop;
    edTop.OnChange     := edTopChange;
    if cbIndTop.Checked then begin
      edIndTop.OnChange  := nil;
      c := ( FControlList.Objects[cbContTop.ItemIndex] as TControl);
      if c = FControl.Parent
        then udIndTop.Position := FContTop
        else udIndTop.Position := FContTop - c.Top - c.Height;
      edIndTop.OnChange  := cbIndTopClick;
    end;
  end;
end;
//==================================================================================================
procedure TBinding.edTopChange( Sender: TObject );
begin
  ContTop := udTop.Position;
end;
//==================================================================================================
procedure TBinding.cbContTopChange( Sender: TObject );
begin
  cbIndTop.Enabled := ( cbContTop.ItemIndex >= 0 );
  cbIndTopClick( Sender );
end;
//==================================================================================================
procedure TBinding.cbIndTopClick( Sender: TObject );
  var c: TControl;
begin
  if cbIndTop.Checked then begin
    c := ( FControlList.Objects[cbContTop.ItemIndex] as TControl);
    if c = FControl.Parent
      then ContTop := udIndTop.Position
      else ContTop := c.Top + c.Height + udIndTop.Position;
  end;
end;
//==================================================================================================
procedure TBinding.cbAnchTopClick( Sender: TObject );
begin
  if cbAnchTop.Checked
    then FControl.Anchors := FControl.Anchors + [akTop]
    else FControl.Anchors := FControl.Anchors - [akTop];
end;
//==================================================================================================
{ Right }
//==================================================================================================
procedure TBinding.SetContRight( const Value: Integer );
  var c: TControl;
begin
  if FContRight <> Value then begin
    FContRight        := Value;
    if cbAnchLeft.Checked
      then FControl.Width := FContRight - FContLeft
      else ContLeft       := FContRight - FControl.Width;
    edRight.OnChange  := nil;
    udRight.Position  := FContRight;
    edRight.OnChange  := edRightChange;
    if cbIndRight.Checked then begin
      edIndRight.OnChange  := nil;
      c := ( FControlList.Objects[cbContRight.ItemIndex] as TControl);
      if c = FControl.Parent
        then udIndRight.Position := c.ClientWidth - FContRight
        else udIndRight.Position := c.Left - FContRight;
      edIndRight.OnChange  := cbIndRightClick;
    end;
  end;
end;
//==================================================================================================
procedure TBinding.edRightChange( Sender: TObject );
begin
  ContRight := udRight.Position;
end;
//==================================================================================================
procedure TBinding.cbContRightChange(Sender: TObject);
begin
  cbIndRight.Enabled := ( cbContRight.ItemIndex >= 0 );
  cbIndRightClick( Sender );
end;
//==================================================================================================
procedure TBinding.cbIndRightClick( Sender: TObject );
  var c: TControl;
begin
  if cbIndRight.Checked then begin
    c := ( FControlList.Objects[cbContRight.ItemIndex] as TControl);
    if c = FControl.Parent
      then ContRight := c.ClientWidth - udIndRight.Position
      else ContRight := c.Left - udIndRight.Position;
  end;
end;
//==================================================================================================
procedure TBinding.cbAnchRightClick( Sender: TObject );
begin
  if cbAnchRight.Checked
    then FControl.Anchors := FControl.Anchors + [akRight]
    else FControl.Anchors := FControl.Anchors - [akRight];
end;
//==================================================================================================
{ Bottom }
//==================================================================================================
procedure TBinding.SetContBottom( const Value: Integer );
  var c: TControl;
begin
  if FContBottom <> Value then begin
    FContBottom        := Value;
    if cbAnchTop.Checked
      then FControl.Height := FContBottom - FContTop
      else ContTop         := FContBottom - FControl.Height;
    edBottom.OnChange  := nil;
    udBottom.Position  := FContBottom;
    edBottom.OnChange  := edBottomChange;
    if cbIndBottom.Checked then begin
      edIndBottom.OnChange  := nil;
      c := ( FControlList.Objects[cbContBottom.ItemIndex] as TControl);
      if c = FControl.Parent
        then udIndBottom.Position := c.ClientHeight - FContBottom
        else udIndBottom.Position := c.Top - FContBottom;
      edIndBottom.OnChange  := cbIndBottomClick;
    end;
  end;
end;
//==================================================================================================
procedure TBinding.edBottomChange( Sender: TObject );
begin
  ContBottom := udBottom.Position;
end;
//==================================================================================================
procedure TBinding.cbContBottomChange(Sender: TObject);
begin
  cbIndBottom.Enabled := ( cbContBottom.ItemIndex >= 0 );
  cbIndBottomClick( Sender );
end;
//==================================================================================================
procedure TBinding.cbIndBottomClick(Sender: TObject);
  var c: TControl;
begin
  if cbIndBottom.Checked then begin
    c := ( FControlList.Objects[cbContBottom.ItemIndex] as TControl);
    if c = FControl.Parent
      then ContBottom := c.ClientHeight - udIndBottom.Position
      else ContBottom := c.Top - udIndBottom.Position;
  end;
end;
//==================================================================================================
procedure TBinding.cbAnchBottomClick(Sender: TObject);
begin
  if cbAnchBottom.Checked
    then FControl.Anchors := FControl.Anchors + [akBottom]
    else FControl.Anchors := FControl.Anchors - [akBottom];
end;
//==================================================================================================
{ TcoBindingMenu }
//==================================================================================================
constructor TcoBindingMenu.Create( AComponent: TComponent; ADesigner: IDesigner );
begin
  inherited Create( AComponent, ADesigner );
  FControl := TControl( AComponent);
end;
//==================================================================================================
procedure TcoBindingMenu.ExecuteVerb(Index: integer);
begin
//  inherited;
  if Index = 0 then BindingControl( FControl );
end;
//==================================================================================================
function TcoBindingMenu.GetVerb(Index: integer): string;
begin
  if Index = 0 then Result := 'Binding Control';
end;
//==================================================================================================
function TcoBindingMenu.GetVerbCount: integer;
begin
  Result := 1;
end;
//==================================================================================================
end.
