{==================================================================================================

  Comming Library

    ComboBox  .

===================================================================================================

  :

  01.09.2007 [*] .
  07.10.2002 [+] Color.
  02.07.2001 [*]   Delphi6.
  13.06.2001 [+]  Enabled:  .
             [*] "" .
  24.12.2000 [+] "".
  19.10.2000 [+]  .  .
  09.09.1998 [!]  Comming Library.

====================================================================================================
  Copyright 19982007 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: CommingComboBoxList.pas,v 1.4 2007/09/03 06:00:09 tsk Exp $
===================================================================================================}
unit CommingComboBoxList;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls{, DesignIntf, CommingBinding}, CommingDisplay, CommingColor;

type
  TcoComboBoxList = class( TCustomComboBox )
  private
    procedure   WMPaint (var Msg : TWMPaint); message WM_PAINT;
    procedure   SetEnabled_( const Value: Boolean );
    function    GetEnabled_: Boolean;
  protected   { Protected declarations }
  public      { Public declarations }
    constructor Create( AOwner: TComponent ); override;
  published   { Published declarations }
//    property Style; {Must be published before Items}
    property Anchors;
    property BiDiMode;
    property Color;
    property Constraints;
    property Ctl3D;
    property DragCursor;
    property DragKind;
    property DragMode;
    property DropDownCount;
    property Enabled: Boolean read GetEnabled_ write SetEnabled_;
    property Font;
    property ImeMode;
    property ImeName;
    property ItemHeight;
    property MaxLength;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property Sorted;
    property TabOrder;
    property TabStop;
    property Text;
    property Visible;
    property OnChange;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnDrawItem;
    property OnDropDown;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMeasureItem;
    property OnStartDock;
    property OnStartDrag;
    property Items; { Must be published after OnMeasureItem }
    property ItemIndex;
  end;

// procedure Register;

implementation

//==================================================================================================
{ TcoComboBoxList }
//==================================================================================================
constructor TcoComboBoxList.Create(AOwner: TComponent);
begin
  inherited Create( AOwner );
  if not ( csDesigning in ComponentState ) then begin
    Color := clDimWindow;
  end;
  Style   := csOwnerDrawFixed;
  Height  := 20;
end;
//==================================================================================================
function TcoComboBoxList.GetEnabled_: Boolean;
begin
  Result := inherited Enabled;
end;
//==================================================================================================
procedure TcoComboBoxList.SetEnabled_( const Value: Boolean );
begin
  inherited Enabled := Value;
  if Enabled then begin
    if not ( csDesigning in ComponentState ) then begin
      Color := clDimWindow;
    end;
  end else begin
    Color := clBtnFace;
  end;
  RecreateWnd;
end;
//==================================================================================================
procedure TcoComboBoxList.WMPaint( var Msg: TWMPaint );
begin
  inherited;
  RepaintFlatBorder( Handle );
end;
//==================================================================================================
end.
