{=======================================================================================================================

  Comming Library.

       .

========================================================================================================================

  :

  09.03.2013 [*] .
  15.11.2011 [*] ReplaceFileLine:    .
  02.09.2011 [*] RecurseDir:     .
  10.06.2011 [*] RecurseDir:       .
  05.01.2011 [*] GetVolumeNo, GetVolumeSerialNumber:   UNC  .
  26.09.2010 [*] NormalFileName:   .
  25.07.2010 [*] ExtractFileNameNoExt:   .
  05.07.2010 [+]  IStorage.
  03.07.2010 [*] ExtractFileNameNoExt:  .
  12.05.2010 [*] GetVolumeLetter:    GetVolumeInformation.
                 GetVolumeName:  .
  10.04.2010 [*] GetVolumeLetter: -  .
  09.10.2009 [*] TakeFileSize:  .
  29.09.2009 [+] NormalFileName:   .
  28.05.2008 [*] GetVolumeSerialNumber:     .
  22.05.2008 [+] GetVolumeSerialNumber:   .
  25.09.2007 [+] ExtractFilePathFormat:      .
  16.10.2006 [+] ExtractFilePathNameNoExt:     ,   .
  26.05.2006 [+] ZIPFile:    zip-.
  14.03.2005 [*] .
  28.11.2004 [*] ExtractFileNameNoExt:     .
  17.08.2004 [*] ReplaceFileLine:    ,   .
  16.08.2004 [+] ReplaceFileLine:    .
  11.09.2003 [*] TakeFileSize:    read-only .
  03.09.2003 [+] TakeFileSize:   .
  07.12.2002 [*] RecurseDir:  .
  31.07.2002 [*] GetDiskKind:  .
             [*] GetVolumeName:     .
  28.06.2002 [-] .
  04.06.2001 [+] GetVolumeName:   .
  10.05.2001 [+]  .
  09.09.1998 [!]  Comming Library.

========================================================================================================================
  Copyright 19982013 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: CommingFile.pas,v 1.31 2013/03/11 05:23:29 tsk Exp $
=======================================================================================================================}
unit CommingFile;

interface

  uses  Windows, Classes, SysUtils, Forms, ShellAPI, ActiveX, AxCtrls, ComObj, Graphics, Jpeg,
        // Comming:
        CommingString;

  //     ()  :
  function    GetVolumeNo( Drive: String ): Integer;
  //     ()  :
  function    GetVolumeSerialNumber( Drive: String ): String;
  //    ():
  function    GetVolumeName( Drive: Char ): String;
  //    ()   :
  function    GetVolumeLetter( Name: String ): String;
  //   :
  function    GetDiskKind( Drive: Char ): Integer;
  //   :
  function    TakeFileSize( FileName: String ): Int64;
  //     :
  function    ExtractFileNameNoExt( FileName: String ): String;
  function    ExtractFileDirectory( FileName: String ): String;
  //     ,     :
  function    ExtractFilePathNameNoExt( FileName: String ): String;
  //       Format.
  function    ExtractFilePathFormat( FileName: String ): String;
  //      :
  procedure   RecurseDir( PathInicial, Ext: String; var FileList: TStringList; Correct: String = '<.>'  );
  //   '/'   ,  :
  function    NormalDir( const DirName: String ): String;
  //   :
  function    NormalFileName( FileName: String ): String;
  //    :
  procedure   ReplaceFileLine( FileName, SepBeg, SepEnd: String; Data: TStringList;
                               FileBlank: String = ''; New: Boolean = False  );
  //   pkzip25.
  procedure   ZIPFile( FileName: String );

  //  IStorage.
  procedure   IStorageCreate( FileName: String );
  procedure   IStorageOpen( FileName: String );
  procedure   IStorageWrite( Name, Data: String ); overload;
  procedure   IStorageWrite( Name: String; Data: TGraphic ); overload;
  procedure   IStorageWrite( Name: String; Data: TStrings ); overload;
  function    IStorageReadString( Name: String ): String;
  function    IStorageReadGraphic( Name: String ): TGraphic;
  function    IStorageReadMemo( Name: String ): TStrings;
  procedure   IStorageClose;

resourcestring
  erNotSeparator = '  %s   %s';
  erNotFileBlank = '  %s   %s';
  erNotPath      = '  %s    ';

var StgFile: IStorage;

implementation
//======================================================================================================================
function  GetVolumeNo( Drive: String ): Integer;
  var V: Array[0..11] of Char;
      S: Array[0..5] of Char;
      N: DWord;
      M, I: DWORD;
begin
  if Length( Drive ) = 1 then Drive := Drive + ':\';
  GetVolumeInformation( PChar( Drive ), @V, MAX_PATH, @N, M, I, @S, 5 );
  Result := N;
end;
//======================================================================================================================
function GetVolumeSerialNumber( Drive: String ): String;
  var n: Integer;
begin
  n := GetVolumeNo( Drive );
  Result := IntToHex( HiWord( n ), 4 ) + '-' + IntToHex( LoWord( n ), 4 )
end;
//======================================================================================================================
function GetVolumeName( Drive: Char ): String;
  var VolumeName : array [0..MAX_PATH] of Char;
      na, nb, nc: DWORD;
begin
  Result := '';
  if GetVolumeInformation( PChar( Drive + ':\'), VolumeName, SizeOf(VolumeName), @na, nb, nc, nil, 0 )
    then Result := VolumeName;
end;
//======================================================================================================================
function GetVolumeLetter( Name: String ): String;
  var VolumeName : array [0..MAX_PATH] of Char;
      na, nb, nc: DWORD;
      i: Integer;
begin
  Result := '?';
  for i := 65 to 90 do
    if GetVolumeInformation( PChar( Char(i) + ':\'), VolumeName, SizeOf(VolumeName), @na, nb, nc, nil, 0 )
        and ( UpperCase( VolumeName ) = UpperCase( Name )) then Result := Char(i);
end;
//======================================================================================================================
function GetDiskKind( Drive: Char ): Integer;
begin
  Result := GetDriveType( PChar( Drive + ':\' ));
end;
//======================================================================================================================
function TakeFileSize( FileName: String ): Int64;
begin
  with TFileStream.Create( FileName, fmOpenRead or fmShareDenyWrite) do
    try
      Result := Size;
    finally
      Free;
    end;
end;
//======================================================================================================================
function ExtractFileNameNoExt( FileName: String ):String;
begin
  Result := ChangeFileExt( ExtractFileName( FileName ), '' );
end;
//======================================================================================================================
function ExtractFileDirectory( FileName: String ): String;
begin
  Result := ExtractFileDir( FileName );
  if ( Length( Result ) >= 2 ) and ( Result[2] = ':' )
    then Result := Copy( Result, 3, Length( Result ) )
end;
//======================================================================================================================
function ExtractFilePathNameNoExt( FileName: String ): String;
begin
  Result := ExtractFileDir( FileName ) + '\' + ExtractFileNameNoExt( FileName );
end;
//======================================================================================================================
function ExtractFilePathFormat( FileName: String ): String;
begin
  Result := ExtractFileDir( FileName ) + '\%s.' + ExtractFileExt( FileName );
end;
//======================================================================================================================
procedure RecurseDir( PathInicial, Ext: String; var FileList: TStringList; Correct: String );
  var SearchRec: TSearchRec;
      Result: Integer;
begin
  Result := FindFirst( PathInicial + '*.*', faAnyFile, SearchRec);
  while Result = 0 do begin
    if ( SearchRec.Name[1] <> '.' ) and ( Pos( Correct, SearchRec.Name ) = 0 ) then begin
      //  :
      if ( SearchRec.Attr and faDirectory ) > 0 then begin
        //  :
        RecurseDir( PathInicial + SearchRec.Name + '\', Ext, FileList, Correct )
      end else begin
        if ( UpperCase( ExtractFileExt( SearchRec.Name )) = '.' + UpperCase( Ext ))
          then FileList.Add( PathInicial + SearchRec.Name );
      end;
    end;
    Application.ProcessMessages;
    Result := FindNext( SearchRec );
  end;
  FindClose( SearchRec );
end;
//======================================================================================================================
function NormalDir( const DirName: String): String;
begin
  Result := DirName;
  if Result = EmptyStr then exit;
  if Result[ Length( Result )] <> '\' then Result := Result + '\';
end;
//======================================================================================================================
function NormalFileName( FileName: String ): String;
begin
  Result := DeleteChars( FileName, '<>"\/*:?|');
end;
//======================================================================================================================
procedure ReplaceFileLine( FileName, SepBeg, SepEnd: String; Data: TStringList; FileBlank: String; New: Boolean );
  var Fil, Tmp: TStringList;
      i, j: Integer;
      Ins: Boolean;
begin
  Fil := TStringList.Create;
  Tmp := TStringList.Create;
  if FileExists( FileName ) and ( not New )
    then Fil.LoadFromFile( FileName )
    else if FileExists( FileBlank )
           then Fil.LoadFromFile( FileBlank )
           else raise EAbort.CreateFmt( erNotFileBlank, [ FileName, FileBlank ]);
  Ins := False;
  for i := 0 to Fil.Count - 1  do begin
    if ( Pos( SepBeg, Fil[i] ) > 0 ) then begin
      Tmp.Add( Fil[i] );
      for j := 0 to Data.Count - 1 do Tmp.Add( Data[j] );
      Ins := True;
    end else if ( Pos( SepEnd, Fil[i] ) > 0 ) then begin
      Tmp.Add( Fil[i] );
      Ins := False
    end else if not Ins then Tmp.Add( Fil [i] )
  end;
  if Ins then raise EAbort.CreateFmt( erNotSeparator, [ FileName, SepEnd ]);
  if not ForceDirectories( ExtractFilePath( FileName ))
    then raise EAbort.CreateFmt( erNotPath, [ FileName ]);
  Tmp.SaveToFile( FileName );
  Tmp.Free;
  Fil.Free;
end;
//======================================================================================================================
procedure ZIPFile( FileName: String );
  var sZIP: String;
begin
  sZIP := ChangeFileExt( FileName, '.zip');
  ShellExecute( Application.Handle, 'open', 'pkzip25',
                PChar( Format( ' -add -move "%s" "%s"', [ sZIP, FileName ])),
                nil, SW_SHOWNORMAL );
end;
//======================================================================================================================
procedure IStorageCreate( FileName: String );
  var pFN: PWideChar;
begin
  pFN := StringToOleStr( FileName );
  StgCreateDocfile( pFN, STGM_CREATE or STGM_READWRITE or STGM_DIRECT or STGM_SHARE_EXCLUSIVE, 0, StgFile );
end;
//======================================================================================================================
procedure IStorageOpen( FileName: String );
  var pFN: PWideChar;
begin
  pFN := StringToOleStr( FileName );
  StgOpenStorage( pFN, nil, STGM_READWRITE or STGM_SHARE_EXCLUSIVE, nil, 0, StgFile );
end;
//======================================================================================================================
procedure IStorageWrite( Name, Data: String );
  var StgStream: IStream;
      OLEStream: TOleStream;
      pNM: PWideChar;
begin
  pNM := StringToLPOLESTR( Name );
  StgFile.CreateStream ( pNM, STGM_CREATE or STGM_READWRITE or STGM_DIRECT or STGM_SHARE_EXCLUSIVE, 0, 0, StgStream );
  OLEStream := TOleStream.Create( StgStream );
  try
    OLEStream.WriteBuffer( Pointer( Data )^, Length( Data ));
  finally
    OLEStream.Free;
    StgStream := nil;
  end;
end;
//======================================================================================================================
procedure IStorageWrite( Name: String; Data: TGraphic );
  var StgStream: IStream;
      OLEStream: TOleStream;
      pNM: PWideChar;
begin
  pNM := StringToLPOLESTR( Name );
  StgFile.CreateStream ( pNM, STGM_CREATE or STGM_READWRITE or STGM_DIRECT or STGM_SHARE_EXCLUSIVE, 0, 0, StgStream );
  OLEStream := TOleStream.Create( StgStream );
  try
    Data.SaveToStream( OLEStream );
  finally
    OLEStream.Free;
    StgStream := nil;
  end;
end;
//======================================================================================================================
procedure IStorageWrite( Name: String; Data: TStrings );
  var StgStream: IStream;
      OLEStream: TOleStream;
      pNM: PWideChar;
begin
  pNM := StringToLPOLESTR( Name );
  StgFile.CreateStream ( pNM, STGM_CREATE or STGM_READWRITE or STGM_DIRECT or STGM_SHARE_EXCLUSIVE, 0, 0, StgStream );
  OLEStream := TOleStream.Create( StgStream );
  try
    Data.SaveToStream( OLEStream );
  finally
    OLEStream.Free;
    StgStream := nil;
  end;
end;
//======================================================================================================================
function  IStorageReadString( Name: String ): String;
  var StgStream: IStream;
      OLEStream: TOleStream;
      pNM: PWideChar;
      buff: String;
begin
  pNM := StringToLPOLESTR( Name );
  StgFile.OpenStream ( pNM, nil, STGM_READWRITE or STGM_SHARE_EXCLUSIVE, 0, StgStream );
  OLEStream := TOleStream.Create( StgStream );
  try
    SetLength( buff, OLEStream.Size );
    OLEStream.ReadBuffer( Pointer(buff)^, OLEStream.Size );
  finally
    OLEStream.Free;
    StgStream := nil;
  end;
  Result := buff;
end;
//======================================================================================================================
function IStorageReadGraphic( Name: String ): TGraphic;
  var StgStream: IStream;
      OLEStream: TOleStream;
      pNM: PWideChar;
      buff: TJPEGImage;
begin
  pNM := StringToLPOLESTR( Name );
  StgFile.OpenStream ( pNM, nil, STGM_READWRITE or STGM_SHARE_EXCLUSIVE, 0, StgStream );
  OLEStream := TOleStream.Create( StgStream );
  buff := TJPEGImage.Create;
  try
    buff.LoadFromStream( OLEStream );
  finally
    OLEStream.Free;
    StgStream := nil;
  end;
  Result := buff;
end;
//======================================================================================================================
function IStorageReadMemo( Name: String ): TStrings;
  var StgStream: IStream;
      OLEStream: TOleStream;
      pNM: PWideChar;
      buff: TStringList;
begin
  pNM := StringToLPOLESTR( Name );
  StgFile.OpenStream ( pNM, nil, STGM_READWRITE or STGM_SHARE_EXCLUSIVE, 0, StgStream );
  OLEStream := TOleStream.Create( StgStream );
  buff := TStringList.Create;
  try
    buff.LoadFromStream( OLEStream );
  finally
    OLEStream.Free;
    StgStream := nil;
  end;
  Result := buff;
end;
//======================================================================================================================
procedure IStorageClose;
begin
  StgFile := nil;
end;
//======================================================================================================================
end.
