{=======================================================================================================================

  Comming Library

     .

========================================================================================================================

  :

  28.05.2003 [*] PressPanelToPanel:    .
  29.11.2002 [-] .
             [*]    CommingDesign  CommingRuntime
  14.11.2002 [-]  TAB.
  15.02.2002 [+] OwnerForm: -.
  01.12.2001 [+]      Hint.
  09.01.2001 [+]  ControlFullName (   ).
  25.08.2000 [*]  Icon  Bitmap  .
  09.09.1998 [!]  Comming Library.

========================================================================================================================
  Copyright 19972012 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: CommingOther.pas,v 1.15 2012/02/08 07:48:22 tsk Exp $
=======================================================================================================================}
unit CommingOther;

interface

  uses Windows, SysUtils, Controls, Menus{, Gauges}, ExtCtrls, Forms, Graphics, Variants,
       Classes;

  function  iif( bCond: Boolean; xIfTrue, xIfFalse: Variant ): Variant;
//  function  ifFindKey( xTable: TTable; aFind: Array of Const; sField: String; xIfFalse: Variant ): Variant;

  function  Empty( Value: Variant ): Boolean;
  function  VarToText( Value: Variant ): String;
  function  ArrayToList( const Args: array of const): string;

//  function   FloatToSQL( const Format: string; Value: Extended): string;

  function  Bottom( Obj: TControl ): Integer;
  function  ControlRight( Obj: TControl ): Integer;
  function  ControlFullName( Obj: TControl ): String;

  procedure PressPanelToPanel( var BasePanel: TPanel; var ChildPanel: TPanel; Align: TAnchors = []);

  procedure SwitchNextItemPopMenu( Menu: TPopupMenu );

//  function  GetGaugeercentDone( Gauge: TGauge ): Longint;

  function  GetExePath: String;

  function  IconToBitmap( Icon: TIcon): TBitmap;
  function  BitmapToIcon( Bitmap: TBitmap): TIcon;

{   ""   TWinControl-. }
  type TFlatControl = class( TWinControl )
    public
      property BevelKind;
      property BevelInner;
      property BevelWidth;
  end;

  procedure   SetFlat( Obj: TWinControl );

  procedure   SetFocusShowHint( Control: TWinControl );

  function    OwnerForm( C: TComponent ): TForm;

implementation
//======================================================================================================================
function iif( bCond: Boolean; xIfTrue, xIfFalse: Variant ): Variant;
begin
  if bCond then Result := xIfTrue else Result := xIfFalse;
end;
//======================================================================================================================
function Empty( Value: Variant ): Boolean;
begin
  case VarType( Value ) of
    varEmpty:     Result := True;
    varNull:      Result := True;
    varSmallint:  Result := ( Value = 0 );
    varInteger:   Result := ( Value = 0 );
    varSingle:    Result := ( Value = 0 );
    varDouble:    Result := ( Value = 0 );
    varCurrency:  Result := ( Value = 0 );
    varDate:      Result := ( Value = 0 );
//  varOleStr   = $0008;
//  varDispatch = $0009;
//  varError    = $000A;
    varBoolean:    Result := not Value;
//    varVariant:  = $000C;
//    varUnknown  = $000D;
//    varByte     = $0011;
//    varStrArg   = $0048;
    varString, varOleStr:
      Result := ( Length( Value ) = 0 ) or ( Value = #0 );
//    varAny      = $0101;
//  varTypeMask = $0FFF;
    varArray:      Result := ( Length( Value ) = 0 );
//  varByRef    = $4000;varEmpty    = $0000;
  else raise Exception.CreateFmt( '  .    %x.',
                                  [ VarType( Value ) ] );
  end;
end;
//======================================================================================================================
function  VarToText( Value: Variant ): String;
  var i: Integer;
begin
  if ( VarType( Value ) AND varArray ) > 0 then begin
    Result := '';
    for i := 0 to Length( Value )
      do Result := Result + VarToStr( Value[i] ) + #13#10
  end else Result := VarToStr( Value )
end;
//======================================================================================================================
function  ArrayToList( const Args: array of const): string;
  var i: Integer;
begin
  Result := '';
  for i := 0 to High( Args ) do begin
    with Args[I] do
      case VType of
        vtInteger:    Result := Result + IntToStr(VInteger);
        vtBoolean:    Result := Result + BoolToStr(VBoolean);
        vtChar:       Result := Result + VChar;
        vtExtended:   Result := Result + FloatToStr(VExtended^);
        vtString:     Result := Result + VString^;
        vtPChar:      Result := Result + VPChar;
        vtObject:     Result := Result + VObject.ClassName;
        vtClass:      Result := Result + VClass.ClassName;
        vtAnsiString: Result := Result + string(VAnsiString);
        vtCurrency:   Result := Result + CurrToStr(VCurrency^);
        vtVariant:    Result := Result + string(VVariant^);
        vtInt64:      Result := Result + IntToStr(VInt64^);
      end;
    if (i > 0 ) then Result := Result + ', ';
  end;
end;
//======================================================================================================================
function  Bottom( Obj: TControl ): Integer;
begin
  Result := Obj.Top + iif( Obj.Visible, Obj.Height, 0 );
end;
//======================================================================================================================
function  ControlRight( Obj: TControl ): Integer;
begin
  Result := Obj.Left + iif( Obj.Visible, Obj.Width, 0 );
end;
//======================================================================================================================
procedure SwitchNextItemPopMenu( Menu: TPopupMenu );
  var i, CurrItem: Integer;
begin
  with Menu do begin
    CurrItem := 0;
    for i := 0 to Items.Count - 1 do if Items[i].Checked then CurrItem := i;
    Inc( CurrItem );
    if CurrItem = Items.Count then CurrItem := 0;
    Items[CurrItem].Click;
  end;
end;
//======================================================================================================================
procedure PressPanelToPanel( var BasePanel: TPanel; var ChildPanel: TPanel; Align: TAnchors );
begin
  if ( Align = [] ) then Align := ChildPanel.Anchors ;
  if akLeft in Align then   ChildPanel.Left := BasePanel.BorderWidth + 1;
  if akRight in Align then  ChildPanel.Left := BasePanel.ClientWidth - ChildPanel.Width - BasePanel.BorderWidth - 1;
  if akTop in Align then    ChildPanel.Top  := BasePanel.BorderWidth + 1;
  if akBottom in Align then ChildPanel.Top  := BasePanel.ClientHeight - ChildPanel.Height - BasePanel.BorderWidth - 1;
  BasePanel.Constraints.MinWidth  := ChildPanel.Width + ( BasePanel.BorderWidth + 1 ) * 2;
  BasePanel.Constraints.MinHeight := ChildPanel.Height + ( BasePanel.BorderWidth + 1 ) * 2;
end;
//======================================================================================================================
function GetExePath: String;
begin
  Result := ExtractFilePath( Application.ExeName );
end;
//======================================================================================================================
function IconToBitmap( Icon: TIcon): TBitmap;
begin
  with TImageList.Create( nil ) do begin
    AddIcon( Icon );
    Result := TBitmap.Create();
    GetBitmap( 0, Result );
    Free;
  end;
end;
//======================================================================================================================
function BitmapToIcon( Bitmap: TBitmap): TIcon;
begin
  with TImageList.Create( nil ) do begin
    Add( Bitmap, nil );
    Result := TIcon.Create;
    GetIcon( 0, Result );
    Free;
  end;
end;
//======================================================================================================================
procedure  SetFlat( Obj: TWinControl );
begin
  with TFlatControl( Obj ) do begin
    BevelKind   := bkTile;
    BevelWidth  := 2;
    BevelInner  := bvNone;
  end;
end;
//======================================================================================================================
function ControlFullName( Obj: TControl ): String;
begin
  Result := '<>';
  try
    Result := Obj.Name + ': ' + Obj.ClassName;
  except end;
end;
//======================================================================================================================
procedure SetFocusShowHint( Control: TWinControl );
  var P: TPoint;
begin
  Windows.SetFocus( Control.Handle );
  P := Control.ClientOrigin;
  Inc( P.X, 4 );
  Inc( P.Y, Control.Height div 2 );
  Mouse.CursorPos := P;
end;
//======================================================================================================================
function OwnerForm( C: TComponent ): TForm;
  var Back: TComponent;
begin
  Back := C.Owner;
  while ( Back <> nil ) and not ( Back is TForm ) do Back := Back.Owner;
  Result := TForm( Back )
end;
//======================================================================================================================
end.
