{===================================================================================================

  Comming Library

     EhLib  .

====================================================================================================

  :

  19.03.2007  [+]  .
  09.09.1998  [!]  Comming Library.

====================================================================================================
  Copyright 19982007 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: CommingAddEh.pas,v 1.2 2007/07/27 06:48:39 tsk Exp $
===================================================================================================}
unit CommingAddEh;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
      Grids, DBGrids, DBGridEh, Math, DB, ADODB,
      // Comming:
      CommingColor, CommingOther;

      function  EHGridEmptyRow( Grid: TDBGridEh ): Integer;
      procedure SortMarkingChanged( Grid: TDBGridEh );
      procedure EHGridHeightBinding( Grid: TDBGridEh; Par: TControl );

  type
    TGridHack = class(TDBGridEh);

implementation
//==================================================================================================
function EHGridEmptyRow( Grid: TDBGridEh ): Integer;
  var C: Integer;
      R: Integer;
begin
  with TGridHack(Grid) do begin
    R := DefaultRowHeight + iif( dgRowLines in Options, GridLineWidth, 0 ); //   .
    C := iif( dgTitles in Options, RowHeights[0], 0 );                      // 
    if FooterRowCount > 0 then C := C + ( R * FooterRowCount ) + 1;         // 
    Result := (( ClientHeight - C ) mod R ) - 1;
  end;
end;
//==================================================================================================
procedure EHGridHeightBinding( Grid: TDBGridEh; Par: TControl );
begin
  Par.Height := Par.Height - EHGridEmptyRow( Grid );
end;
//==================================================================================================
{procedure TcoDBGridEh.SetAutoHeightBinding( const Value: Boolean );
begin
  FAutoHeightBinding := Value;
end;
//==================================================================================================
function TcoDBGridEh.GetHeight: Integer;
begin
  Result := inherited Height;
end;
//==================================================================================================
procedure TcoDBGridEh.SetHeight( const Value: Integer );
begin
  inherited Height := Value;
  if FAutoHeightBinding and ( GetEmptyRow <> 0 ) then HeightBinding;
end;}
//==================================================================================================
{procedure TcoDBGridEh.SettingMarker( PosSet: String );
  var i: Integer;
begin
 for i := 0 to Columns.Count - 1 do
  if i < Length( PosSet ) then
    case PosSet[i+1] of
      'U','u' : Columns[i].Title.SortMarker := smUpEh;
      'D','d' : Columns[i].Title.SortMarker := smDownEh
      else Columns[i].Title.SortMarker := smNoneEh;
    end
  else Columns[i].Title.SortMarker := smNoneEh;
end;
//==================================================================================================
procedure TcoDBGridEh.ClearMarker;
  var i: Integer;
begin
 for i := 0 to Columns.Count - 1 do Columns[i].Title.SortMarker := smNoneEh;
end;
//==================================================================================================
procedure TcoDBGridEh.SetShowHintData( const Value: Boolean );
begin
  if FShowHintData <> Value then begin
    if Value and ( not Assigned( OnDblClick )) then begin
      FShowHintData := True;
      ShowHint      := True;
      OnDblClick    := HintDataShow;
    end else if FShowHintData then begin
      OnDblClick    := nil;
      FShowHintData := False;
    end else begin
      FShowHintData := False;
    end;
  end;
end;
//==================================================================================================
procedure TcoDBGridEh.HintDataShow( Sender: TObject );
begin
  FShowHintDataActive := True;
end;
//==================================================================================================
procedure TcoDBGridEh.CMHintShow( var Message: TCMHintShow );
  var Data: String;
      i: Integer;
begin
  if FShowHintDataActive then begin
    Data := '';
    with DataSource.DataSet do
      for i := 0 to FieldCount - 1
        do if Fields[i].Visible then Data := Data + iif( i = 0, '', #10 ) + Fields[i].DisplayLabel + ': ' + Fields[i].DisplayText;
    Message.HintInfo.HintStr      := Data;
//    Message.HintInfo.HideTimeout  := 0;
    FShowHintDataActive := False;
  end;
  inherited
end;
//==================================================================================================
function TcoDBGridEh.ColumnByField( Field: TField ): TColumnEh;
  var i: Integer;
begin
  Result := Columns[ 0 ];
  for i := 0 to ColCount - 1 do
    if Columns[ i ].Field = Field then Result := Columns[ i ]
end;}
//==================================================================================================
procedure SortMarkingChanged( Grid: TDBGridEh);
  var i: Integer;
      s: String;
      b: TBookmark;
begin
  Screen.Cursor := crHourGlass;
  with Grid do begin
    b := DataSource.DataSet.GetBookmark;
    s := '';
    for i := 0 to SortMarkedColumns.Count - 1 do begin
      if Empty( SortMarkedColumns[i].EditMask )
        then s := s + SortMarkedColumns[i].FieldName
        else s := s + SortMarkedColumns[i].EditMask;
      if ( SortMarkedColumns[i].Title.SortMarker = smDownEh )
        then s := s + ' DESC';
      s := s + ';';
    end;
    TADODataSet(DataSource.DataSet).IndexFieldNames := s;
    DataSource.DataSet.GotoBookmark( b );
  end;
  Screen.Cursor := crDefault;
end;
//==================================================================================================
end.
