{===================================================================================================

  Comming Library

       36- .

====================================================================================================

  :

  09.09.1998 TSK   Comming Library.

====================================================================================================
  Copyright 1999-2000 TSK Developer Laboratory, Moscow.             Konstantin Tsvetkov
                                                                           e-mail: tsklab@mail.ru
===================================================================================================}
unit Comming36;

interface

  uses SysUtils;

	function IntExp( Num, Exp: Integer ): Integer;
	function IntToStr36( Num, Len: Integer ): String;
	function Str36ToInt( Num: String ): Integer;
	function Inc36( Num: String ): String;
	function IntToStr62( Num, Len: Integer ): String;
	function Str62ToInt( Num: String ): Integer;

implementation

//=============================================================================================
function IntExp( Num, Exp: Integer ): Integer;
	var i: Integer;
begin
	Result := 1;
	for i := 1 to Exp do Result := Result * Num;
end;
//==================================================================================================
function x36Char( X: Integer ): Char;
begin
	case X of
		0..9: 	Result := Chr( X + 48 );
		10..35:	Result := Chr( X + 55 );
		else Result := 'a' ;
	end;
end;
//=============================================================================================
function x62Char( X: Integer ): Char;
begin
	case X of
		0..9: 	Result := Chr( X + 48 );
		10..35:	Result := Chr( X + 55 );
		36..61: Result := Chr( X + 61 );
		else Result := '~' ;
	end;
end;
//=============================================================================================
function x36Int( X: Char ): Integer ;
begin
	Result := Ord( X );
	if Result < 58
		then Result := Result - 48
		else Result := Result - 55;
end;
//=============================================================================================
function x62Int( X: Char ): Integer ;
begin
	Result := Ord( X );
	case Result of
		48..57: 	Dec( Result, 48 );
		65..90:		Dec( Result, 55 );
		97..122:	Dec( Result, 61 );
		else Result := 0;
	end;
end;
//=============================================================================================
function IntToStr36( Num, Len: Integer ): String;
	var i, b: Integer;
begin
	Result := '';
	if Len = 0 then
		while ( IntExp( 36, Len ) < Num ) and ( Len < 6 ) do Inc( Len );
	for i := Len - 1 downto 0 do
		begin
			b := IntExp( 36, i );
			Result := Result + x36Char( Num div b );
			Num := Num mod b;
		end;
end;
//=============================================================================================
function IntToStr62( Num, Len: Integer ): String;
	var i, b: Integer;
begin
	Result := '';
	if Len = 0 then
		while ( IntExp( 62, Len ) < Num ) and ( Len < 6 ) do Inc( Len );
	for i := Len - 1 downto 0 do
		begin
			b := IntExp( 62, i );
			Result := Result + x62Char( Num div b );
			Num := Num mod b;
		end;
end;
//=============================================================================================
function Str36ToInt( Num: String ): Integer;
	var i, l, b: Integer;
begin
	Result := 0;
	l := Length( Num );
	for i := 1 to Length( Num )  do
		begin
			b := IntExp( 36, l - i );
			Result := Result + ( x36Int( Num[i] ) * b );
		end;
end;
//=============================================================================================
function Str62ToInt( Num: String ): Integer;
	var i, l, b: Integer;
begin
	Result := 0;
	l := Length( Num );
	for i := 1 to Length( Num )  do
		begin
			b := IntExp( 62, l - i );
			Result := Result + ( x62Int( Num[i] ) * b );
		end;
end;
//=============================================================================================
function Inc36( Num: String ): String;
	var l: Integer;
begin
	l := Length( Num );
	Result := Num;
	if Num[1] = 'a' then exit;
	Result := IntToStr36( Str36ToInt( Num ) + 1, l );
end;
//=============================================================================================
end.
