{ ==================================================================================================}
{                                                                                                  }
{   -     Pervasive.SQL    TRxMemoryData.                                 }
{   Copyright 1999-2000 TSK Developer Laboratory, Moscow.                                          }
{                                                                                                  }
{                                                                              Konstantin Tsvetkov }
{                                                                           e-mail: tsklab@mail.ru }
{==================================================================================================}
unit CommingMemoryData;
{ TODO 1 -oTSK : H ! }
interface

	uses SysUtils, Forms, BseMain, BtrMain, RxMemDS, DB;

	procedure	PSQLSelectToMemory( Query: TtbQuery; SQLText: String;
																var Data: TRxMemoryData; CopyStructure: Boolean = True ); overload;
	procedure	PSQLSelectToMemory( Query: TtbQuery; SQLText: String; const Args: array of const;
																var Data: TRxMemoryData; CopyStructure: Boolean = True ); overload;
	procedure	PSQLSelectToMemory( SQLDataBase, SQLText: String;
																var Data: TRxMemoryData; CopyStructure: Boolean = True ); overload;
	procedure	PSQLSelectToMemory( SQLDataBase, SQLText: String; const Args: array of const;
																var Data: TRxMemoryData; CopyStructure: Boolean = True ); overload;
	procedure	PSQLRowSelectToMemory( Query: TtbQuery; SQLText: String;
																var Data: TRxMemoryData; FieldBegin: Integer = 0 ); overload;
	procedure	PSQLRowSelectToMemory( Query: TtbQuery; SQLText: String; const Args: array of const;
																var Data: TRxMemoryData; FieldBegin: Integer = 0 ); overload;

implementation
//==================================================================================================
procedure	CopyRowToMemory( Query: TtbQuery; var Data: TRxMemoryData; FieldBegin: Integer );
	var i: Integer;
begin
	for i := 0 to Query.Fields.Count - 1 do begin
		if Query.Fields[i].DataType = ftString
			then ( Query.Fields[i] as TStringField ).Transliterate := False;
		Data.Fields[ FieldBegin + i ].Value := Query.Fields[i].Value;
	end;
end;
//==================================================================================================
procedure	CopyQueryToMemory( Query: TtbQuery; var Data: TRxMemoryData; CopyStructure: Boolean );
	var i: Integer;
begin
	if CopyStructure then begin
		Data.Close;
		Data.CopyStructure( Query );
		Data.Open;
	end;
	Query.Last;
	while not Query.Bof do begin
		Data.Insert;
		for i := 0 to Query.Fields.Count - 1 do Data.Fields[i].Value := Query.Fields[i].Value;
		Data.Post;
		Query.Prior;
	end;
end;
//==================================================================================================
procedure	PSQLSelectToMemory( Query: TtbQuery; SQLText: String;
															var Data: TRxMemoryData; CopyStructure: Boolean = True ); overload;
begin
	with Query do begin
		SQL.Text := SQLText;
		Open;
	end;
	CopyQueryToMemory( Query, Data, CopyStructure );
end;
//==================================================================================================
procedure	PSQLSelectToMemory( Query: TtbQuery; SQLText: String; const Args: array of const;
															var Data: TRxMemoryData; CopyStructure: Boolean = True ); overload;
begin
	PSQLSelectToMemory( Query, Format( SQLText, Args ), Data, CopyStructure );
end;
//==================================================================================================
procedure	PSQLSelectToMemory( SQLDataBase, SQLText: String;
															var Data: TRxMemoryData; CopyStructure: Boolean = True ); overload;
	var Query: TtbQuery;
begin
	Query := TtbQuery.Create(nil);
	try
		with Query do begin
			DatabaseName := SQLDataBase;
			SQL.Text := SQLText;
			Open;
		end;
		CopyQueryToMemory( Query, Data, CopyStructure );
	finally
		Query.Free;
	end;
end;
//==================================================================================================
procedure	PSQLSelectToMemory( SQLDataBase, SQLText: String; const Args: array of const;
															var Data: TRxMemoryData; CopyStructure: Boolean = True); overload;
begin
	PSQLSelectToMemory( SQLDataBase, Format( SQLText, Args ), Data, CopyStructure );
end;
//==================================================================================================
procedure	PSQLRowSelectToMemory( Query: TtbQuery; SQLText: String;
															var Data: TRxMemoryData; FieldBegin: Integer = 0 ); overload;
begin
	with Query do begin
		SQL.Text := SQLText;
		Open;
	end;
	CopyRowToMemory( Query, Data, FieldBegin );
end;
//==================================================================================================
procedure	PSQLRowSelectToMemory( Query: TtbQuery; SQLText: String; const Args: array of const;
															var Data: TRxMemoryData; FieldBegin: Integer = 0 ); overload;
begin
	PSQLRowSelectToMemory( Query, Format( SQLText, Args ), Data, FieldBegin );
end;
//==================================================================================================
end.
