unit CommingRxDBGrid;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, RXDBCtrl;

type
	TcoRxDBGrid = class(TRxDBGrid)
	private
		{ Private declarations }
		FSortColumn: Integer;
		FTitleHeight: Integer;
		procedure	SetSortColumn( Value: Integer );
	protected
		{ Protected declarations }
	public
		{ Public declarations }
		constructor Create( AOwner: TComponent); override;
		procedure AlignmentVerticality;
		procedure AlignmentHorizontally;
		procedure AlignmentBouth;
	published
		{ Published declarations }
		property 	SortColumn: Integer read FSortColumn write SetSortColumn;
		property	TitleHeight: Integer read FTitleHeight;
	end;

procedure Register;

implementation
//=============================================================================================
constructor TcoRxDBGrid.Create( AOwner: TComponent);
begin
	inherited Create( AOwner );
	FTitleHeight 		:= RowHeights[0];
	Options 				:= [dgTitles,dgColLines,dgRowLines,dgRowSelect,dgAlwaysShowSelection,
											dgConfirmDelete, dgCancelOnExit];
	TitleButtons		:= True;
	TitleFont.Style	:= [fsBold];
end;
//=============================================================================================
procedure TcoRxDBGrid.AlignmentVerticality;
	var iRow, iNumb, iLine: Integer;
begin
	iRow := DefaultRowHeight;
	if dgRowLines in Options then iLine := GridLineWidth else iLine := 0;
	Inc(iRow, iLine);
	iNumb := Round( Int( ( ClientHeight - FTitleHeight ) / iRow ) );
	RowHeights[0] := ClientHeight - ( iRow * iNumb );
	if HandleAllocated then Perform(WM_SIZE, SIZE_RESTORED, MakeLong(ClientWidth, ClientHeight));
end;
//=============================================================================================
procedure TcoRxDBGrid.AlignmentHorizontally;
	const iBase = 100;
	var i, iFixWidth, iLineWidth, iLastCol, iLastWidth: Integer;
			fRel, fNewBase: Double;
begin
	iFixWidth   := 0;
	iLastCol    := 0;
	if dgColLines in Options
		then iLineWidth := GridLineWidth
		else iLineWidth := 0;
	fRel        := 0;
	for i := 0 to Columns.Count - 1 do
		if Columns[ i ].ButtonStyle = cbsNone
			then Inc( iFixWidth, Columns[ i ].Width + iLineWidth )
			else
				begin
					iLastCol := i;
					fRel := fRel + ( Columns[ i ].Width / iBase );
				end;
	iLastWidth := ClientWidth - iFixWidth - iLineWidth;
	fNewBase := iLastWidth / fRel;
	for i := 0 to Columns.Count - 1 do
		if Columns[ i ].ButtonStyle <> cbsNone then
			begin
				if i = iLastCol
					then
						begin
							Columns[ i ].Width := iLastWidth;
						end
					else
						begin
							Columns[ i ].Width := Round( fNewBase * ( Columns[ i ].Width / iBase ));
							iLastWidth := iLastWidth - Columns[ i ].Width - iLineWidth;
						end;
			end;
	if HandleAllocated then Perform(WM_SIZE, SIZE_RESTORED, MakeLong(ClientWidth, ClientHeight));
end;
//=============================================================================================
procedure TcoRxDBGrid.AlignmentBouth;
begin
	AlignmentHorizontally;
	AlignmentVerticality;
end;
//=============================================================================================
procedure TcoRxDBGrid.SetSortColumn( Value: Integer );
	var i: Integer;
begin
	if Value <= Columns.Count - 1 then begin
		for i := 0 to Columns.Count - 1 do Columns[i].Title.Font.Color := clWindowText;
		FSortColumn := Value;
		Columns[FSortColumn].Title.Font.Color := clRed;
	end;
end;
//=============================================================================================
procedure Register;
begin
	RegisterComponents('Comming', [TcoRxDBGrid]);
end;
//=============================================================================================
end.
