{ ==================================================================================================}
{                                                                                                  }
{   - TcoSaveCancelPanel.                                                                          }
{                                                                                                  }
{  Copyright 1999-2000 TSK Developer Laboratory, Moscow.                       Konstantin Tsvetkov }
{                                                                           e-mail: tsklab@mail.ru }
{==================================================================================================}
unit CommingSaveCancelPanel;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	ExtCtrls, StdCtrls, ComCtrls, RXCtrls;

type

	TcoSaveCancelPanel = class(TFrame)
		BevelTop: TBevel;
		Panel: TPanel;
		ButtonSave: TRxSpeedButton;
		ButtonCancel: TRxSpeedButton;
	private
		{ Private declarations }
		function 	GetButtonSaveClick(): TNotifyEvent;
		procedure	SetButtonSaveClick( Value: TNotifyEvent );
		function 	GetButtonCancelClick(): TNotifyEvent;
		procedure	SetButtonCancelClick( Value: TNotifyEvent );
	protected
		{ Protected declarations }
	public
		constructor Create( AOwner: TComponent); override;
	published
		{ Published declarations }
		property 	Align;
		property 	OnButtonSaveClick: TNotifyEvent
							read GetButtonSaveClick write SetButtonSaveClick;
		property 	OnButtonCancelClick: TNotifyEvent
              read GetButtonCancelClick write SetButtonCancelClick;
	end;

procedure Register;

implementation

{$R *.DFM}
//==================================================================================================
constructor TcoSaveCancelPanel.Create( AOwner: TComponent);
begin
	inherited Create( AOwner );
	Align := alBottom;
end;
//==================================================================================================
function TcoSaveCancelPanel.GetButtonSaveClick(): TNotifyEvent;
begin
	Result := ButtonSave.OnClick;
end;
//==================================================================================================
procedure TcoSaveCancelPanel.SetButtonSaveClick( Value: TNotifyEvent );
begin
	ButtonSave.OnClick := Value;
end;
//==================================================================================================
function TcoSaveCancelPanel.GetButtonCancelClick(): TNotifyEvent;
begin
	Result := ButtonCancel.OnClick;
end;
//==================================================================================================
procedure TcoSaveCancelPanel.SetButtonCancelClick( Value: TNotifyEvent );
begin
	ButtonCancel.OnClick := Value;
end;
//==================================================================================================
procedure Register;
begin
	RegisterComponents( 'Comming', [TcoSaveCancelPanel] );
end;
//==================================================================================================
end.
