{==================================================================================================

  Comming Library

      .

===================================================================================================

  :

  10.12.2002 TSK     CommingDesign  CommingRuntime
  29.10.2001 TSK   TAB.
                  MaxValue:   published.
  12.10.1999 King  .  .
  09.09.1998 TSK   Comming Library.

===================================================================================================
  Copyright 1998-2002 TSK Developer Laboratory, Moscow.             Konstantin Tsvetkov
                                                                        e-mail: tsklab@mail.ru
  Copyright 1999 Korolev & Son Ltd., Moscow, Russia.                Alexey Korolev
                                                                        e-mail: malta@mail.ru
===================================================================================================}
unit CommingTracer;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
      ExtCtrls, StdCtrls, ComCtrls;

type
  TcoTracer = class( TFRame )
    TitleElapse: TLabel;
    TitleWait: TLabel;
    LabelElapse:  TLabel;
    LabelWait:     TLabel;
  private   { Private declarations }
    FBegTime:   TDateTime;
    FEndTime:   TDateTime;
    FLabelTime: TDateTime;
    FInterval:   TDateTime;
    FMaxValue:   Integer;
    FMeter:     Integer;
    function    GetInterval(): Integer;
    procedure   SetInterval( Value: Integer );
    procedure   SetMaxValue( const Value: Integer );
    procedure   Recalculation;
  protected   { Protected declarations }
  public      { Public declarations }
    constructor Create( AOwner: TComponent ); override;
    procedure   Actuation( iMax: Integer );
    procedure   NextStep;
  published   { Published declarations }
    property    MaxValue: Integer read FMaxValue write SetMaxValue;
    property    Align;
    property    Interval: Integer read GetInterval write SetInterval;
  end;

procedure Register;

implementation

{$R *.DFM}
//==================================================================================================
{ TcoTracer }
//==================================================================================================
constructor TcoTracer.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FInterval := EncodeTime(0, 0, 2, 0);
end;
//==================================================================================================
procedure TcoTracer.Recalculation;
begin
  FEndTime := Time;
  if FEndTime - FLabelTime > FInterval then begin
    LabelElapse.Caption := TimeToStr( FEndTime - FBegTime );
    LabelWait.Caption   := TimeToStr((( FEndTime - FBegTime ) * FMaxValue / FMeter ) -
                                        ( FEndTime - FBegTime ) );
    FLabelTime := Time;
  end;
  Update;
end;
//==================================================================================================
procedure TcoTracer.Actuation( iMax: Integer );
begin
  FMaxValue           := iMax;
  FMeter              := 0;
  LabelElapse.Caption := '0:00:00';
  LabelWait.Caption   := '.....';
  FBegTime            := Time;
  Update;
end;
//=============================================================================================
procedure TcoTracer.NextStep;
begin
  Inc( FMeter );
  Recalculation;
end;
//=============================================================================================
function TcoTracer.GetInterval(): Integer;
  var Hour, Min, Sec, MSec: Word;
begin
  DecodeTime( FInterval, Hour, Min, Sec, MSec );
  Result := Sec;
end;
//=============================================================================================
procedure  TcoTracer.SetInterval( Value: Integer );
begin
  FInterval := EncodeTime( 0, 0, Value, 0 );
end;
//==================================================================================================
procedure TcoTracer.SetMaxValue( const Value: Integer );
begin
  if FMaxValue <> Value then begin
    FMaxValue := Value;
    Recalculation;
  end;
end;
//=============================================================================================
procedure Register;
begin
  RegisterComponents( 'Comming' , [TcoTracer] );
end;
//==================================================================================================
end.
